<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

	//Starts PHP Session
	session_start();
if ($_SESSION['username'] != "")
{	
	//PHP Includes
	include 'create_ss7_ccspans_class.php';
	include '../database_classes.php';
	
	//PHP Class Constructor
	$data = new database_class;
	$ss7_ccspans = new create_ss7_ccspans;
	$ss7_ccspans->data = $data;
		
	$db_location = "sqlite:../sqlite/cardinfo.db";
	$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] . "_SS7_ccspans";
	
	$ss7_ccspans->get_link_info();
	
	//Check the database. If the database exists, use that information to display
	$table_exists = $data->check_for_table ($db_location, $table_name);

	if ($table_exists > 1)
	{
		$param = "port_id, profile_name, isup, cic, channels, min_digits, clg_nadi, cld_nadi, obci_bita, typeCntrl, group_num";
		$where_param = "port_id = " . $_SESSION['port_num_clicked'];
		
		//Grab the information for that port
		$ss7_ccspans->edit = $data->select_statement ($db_location, $table_name, $param, $where_param);
		
		$ss7_ccspans->profile = $ss7_ccspans->edit['profile_name'];
		$ss7_ccspans->cic = $ss7_ccspans->edit['cic'];
		$ss7_ccspans->isup = $ss7_ccspans->edit['isup'];
		$ss7_ccspans->channels = $ss7_ccspans->edit['channels'];
		$ss7_ccspans->min_digits = $ss7_ccspans->edit['min_digits'];
		$ss7_ccspans->clg_nadi = $ss7_ccspans->edit['clg_nadi'];
		$ss7_ccspans->cld_nadi = $ss7_ccspans->edit['cld_nadi'];
		$ss7_ccspans->obci_bita = $ss7_ccspans->edit['obci_bita'];
		$ss7_ccspans->typeCntrl = $ss7_ccspans->edit['typeCntrl'];
		$ss7_ccspans->group_num = $ss7_ccspans->edit['group_num'];		
	}

	if ($_REQUEST['create'] == "Create Channel Map")
	{
		$ss7_ccspans->cic = $_REQUEST['cic'];
		$ss7_ccspans->isup = $_REQUEST['isup'];
		$ss7_ccspans->channels = $_REQUEST['channels'];
		$ss7_ccspans->min_digits = $_REQUEST['min_digits'];
		$ss7_ccspans->clg_nadi = $_REQUEST['clg_nadi'];
		$ss7_ccspans->cld_nadi = $_REQUEST['cld_nadi'];
		$ss7_ccspans->obci_bita = $_REQUEST['obci_bita'];
		$ss7_ccspans->typeCntrl = $_REQUEST['typeCntrl'];	
		$ss7_ccspans->group_num = $_REQUEST['group_num'];		
		
		//Runs the validation script
		$ss7_ccspans->validation();
		
		//If there are no errors, place in the database
		if ($ss7_ccspans->error_counter == 0)
		{
			//create the channel map
			
			//Check if the database needs to be created		
			if ($table_exists < 2)
			{
	
				$param = "port_id int primary key, profile_name varchar(60), isup varchar(30), cic varchar(30), channels varchar(30), min_digits int, clg_nadi int, cld_nadi int, obci_bita int, typeCntrl varchar(30), group_num int";
				$data->create_table($db_location, $table_name, $param);

				//Line doesn't exist, insert it
				$insert_param = "port_id, profile_name, isup, cic, channels, min_digits, clg_nadi, cld_nadi, obci_bita, typeCntrl, group_num";
				$insert_values = $_SESSION['port_num_clicked'] . ", \"" . $_REQUEST['profile_name'] . "\", \"" . $_REQUEST['isup'] . "\", \"" . $_REQUEST['cic'] . "\", \"" . $_REQUEST['channels'] . "\", \"" . $_REQUEST['min_digits'] . "\", \"" . $_REQUEST['clg_nadi'] . "\", \"" . $_REQUEST['cld_nadi'] . "\", \"" . $_REQUEST['obci_bita'] . "\", \"" . $_REQUEST['typeCntrl'] . "\", \"" . $_REQUEST['group_num'] . "\"";
			
				$data->insert_statement($db_location, $table_name, $insert_param, $insert_values);				
			}
			elseif ($table_exists > 1)
			{
				//Check if the line exists
				$param = "port_id";
				$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
				
				if ($result['port_id'] != "")
				{
					//Line exists, update it
					$update_param = "profile_name = \"" . $_REQUEST['profile_name'] . "\", cic = \"" . $_REQUEST['cic'] . "\", isup = \"" . $_REQUEST['isup'] . "\", channels = \"" . $_REQUEST['channels'] . "\", min_digits = \"" . $_REQUEST['min_digits'] . "\", clg_nadi = \"" . $_REQUEST['clg_nadi'] . "\", cld_nadi = \"" . $_REQUEST['cld_nadi'] . "\", obci_bita = \"" . $_REQUEST['obci_bita'] . "\", typeCntrl = \"" . $_REQUEST['typeCntrl'] . "\", group_num = \"" . $_REQUEST['group_num'] . "\"";

					$where_param = "port_id = " . $_SESSION['port_num_clicked'];
				
					$data->update_table($db_location, $table_name, $update_param, $where_param);
				}
				elseif ($result['port_id'] == "")
				{
					//Line doesn't exist, insert it
					$insert_param = "port_id, profile_name, isup, cic, channels, min_digits, clg_nadi, cld_nadi, obci_bita, typeCntrl, group_num";
					$insert_values = $_SESSION['port_num_clicked'] . ", \"" . $_REQUEST['profile_name'] . "\", \"" . $_REQUEST['isup'] . "\", \"" . $_REQUEST['cic'] . "\", \"" . $_REQUEST['channels'] . "\", \"" . $_REQUEST['min_digits'] . "\", \"" . $_REQUEST['clg_nadi'] . "\", \"" . $_REQUEST['cld_nadi'] . "\", \"" . $_REQUEST['obci_bita'] . "\", \"" . $_REQUEST['typeCntrl'] . "\", \"" . $_REQUEST['group_num'] . "\"";
				
					$data->insert_statement($db_location, $table_name, $insert_param, $insert_values);
				}
			}
			
			$_SESSION['profile_num_ccspan']--;

			//Redirects to viewing all profiles page
			header( 'Location:../wanrouterhwprobe.php' ) ;			
		}
		else
		{
			$ss7_ccspans->profile = $_REQUEST['profile_name'];
			$ss7_ccspans->cic = $_REQUEST['cic'];
			$ss7_ccspans->isup = $_REQUEST['isup'];
			$ss7_ccspans->channels = $_REQUEST['channels'];	
			$ss7_ccspans->min_digits = $_REQUEST['min_digits'];
			$ss7_ccspans->clg_nadi = $_REQUEST['clg_nadi'];
			$ss7_ccspans->cld_nadi = $_REQUEST['cld_nadi'];
			$ss7_ccspans->obci_bita = $_REQUEST['obci_bita'];
			$ss7_ccspans->typeCntrl = $_REQUEST['typeCntrl'];
		}
	}
	if ($_REQUEST['cancel'] == "Cancel")
	{
		$_SESSION['id_num'] = "";
		
		$_SESSION['profile_num_isup'] = $_SESSION['profile_num_isup'] - 2;

		//Redirects to viewing all profiles page
		header( 'Location:../wanrouterhwprobe.php' ) ;		
		
	}

	//FusionPBX Integration
	require_once "../fusionpbx/includes/header.php";

	//$display_common->html_title($title, "../../style.css" );	
	
	$ss7_ccspans->display();	
	//$display_common->html_footer();

	//FusionPBX Integration
	require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:../index.php' ) ;
}
?>