<?php
/*
	SMG WebGUI
	Version: 1.1

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

//Starts PHP Session
session_start();

//Includes the File which contains classes
include '../classes.php';
include '../database_classes.php';
include 'configure_t1e1_class.php';

//Class Constructors
//$display_common = new Display_common;
$data = new database_class;
$t1e1 = new t1e1_class;

//Loads information from session variables
$t1e1->card_name = $_SESSION['card_clicked'];
$t1e1->card_num = $_SESSION['card_num'];
$t1e1->port = $_SESSION['port_num_clicked'];

//Database related variables
$db_location="sqlite:../sqlite/cardinfo.db";
$table_name = $t1e1->card_name . "_" . $t1e1->card_num;



//Get information out of the card_present table
$t1e1->display_database($data);

//Check to see if there is anything for the port in question within it's table
$t1e1->get_information($data);

if ($_REQUEST['type'])
{
	$t1e1->t1e1 = $_REQUEST['type'];
	unset($t1e1->database);
}
elseif ($t1e1->database['line_type'])
{
	$t1e1->t1e1 = $t1e1->database['line_type'];
}
elseif ($_SESSION['hw_line'] != "")
{
	$t1e1->t1e1 = $_SESSION['hw_line'];
}
else
{
	$t1e1->t1e1 = "T1";
}
	

//Validates and redirects
if ($_REQUEST['save'] == "Apply to Port" || $_REQUEST['save-all'] == "Apply to all Ports")
{
	//Validate the form
	$t1e1->validate();

	//If there are no errors, place into the database
	if ($t1e1->error_count == 0)
	{
		if ($t1e1->exist < 2)
		{
			//Table does not exist
			$parameters = "port_id int primary key, dev_name varchar(60), line_type varchar(10), coding varchar(10), framing varchar(10), clock varchar(30), ref_clock int, echo varchar(30), dtmf varchar(30), fax varchar(30), lbo varchar(30), txtristate varchar(30), sigmode varchar(10), impedence varchar(30), rx_level varchar(30), rxgain decimal(10,2), txgain decimal(10,2)";
			
			$data->create_table($db_location, $table_name, $parameters);
		}
		
		if ($_REQUEST['save'] == "Apply to Port")
		{
			//Check if the line exists
			$param = "port_id";
			$where_param = "port_id = " . $t1e1->port;
			$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
			
			//echo "result = " . $result['port_id'] . "<br />";
			
			if ($result['port_id'] != "")
			{
				//update
				$update_param = "port_id = " . $t1e1->port . ", dev_name = \"" . $t1e1->card_name . "\", line_type = \"" . $t1e1->t1e1 . "\", coding = \"" .$_REQUEST['coding'] . "\", framing = \"" . $_REQUEST['framing'] . "\", clock = \"" . $_REQUEST['clock'] . "\", ref_clock = \"" . $_REQUEST['ref_clock'] . "\", echo = \"" .$_REQUEST['HW_EC']. "\", dtmf = \"" . $_REQUEST['dtmf'] . "\", fax = \"" . $_REQUEST['HW_FAX'] . "\", lbo = \"" . $_REQUEST['lbo'] . "\", txtristate = \"" . $_REQUEST['txtristate'] . "\", sigmode = \"" . $_REQUEST['sig_mode'] . "\", impedence = \"" . $_REQUEST['impedence'] . "\", rx_level = \"" . $_REQUEST['rx_level'] . "\", rxgain = \"" . $_REQUEST['rxgain'] . "\", txgain = \"" . $_REQUEST['txgain'] . "\"";
				
				$where_param = "port_id = " . $t1e1->port;
				$data->update_table ($db_location, $table_name, $update_param, $where_param);
			}
			else
			{
				$insert_parameters = "port_id, dev_name, line_type, coding, framing, clock, ref_clock, echo, dtmf, fax, lbo, txtristate, sigmode, impedence, rx_level, rxgain, txgain";	
				$values = $t1e1->port . ", \"" . $t1e1->card_name . "\", \"" . $t1e1->t1e1 . "\", \"" .$_REQUEST['coding'] . "\", \"" . $_REQUEST['framing'] . "\", \"" . $_REQUEST['clock'] . "\",\"" . $_REQUEST['ref_clock'] . "\", \"" .$_REQUEST['HW_EC']. "\", \"" . $_REQUEST['dtmf'] . "\", \"" . $_REQUEST['HW_FAX'] . "\", \"" . $_REQUEST['lbo'] . "\", \"" . $_REQUEST['txtristate'] . "\", \"" . $_REQUEST['sig_mode'] . "\", \"" . $_REQUEST['impedence'] . "\", \"" . $_REQUEST['rx_level'] . "\", \"" . $_REQUEST['rxgain'] . "\", \"" . $_REQUEST['txgain'] . "\"";
									
				$data->insert_statement($db_location, $table_name, $insert_parameters, $values);
			}
			
			//redirect to status page
			header( 'Location:../wanrouterhwprobe.php' );								
		}
		elseif ($_REQUEST['save-all'] == "Apply to all Ports")
		{
			for ($a = 1; $a <= $t1e1->num_ports; $a++)
			{
				//Check if the line exists
				$param = "port_id";
				$where_param = "port_id = " . $a;
				$result = $data->select_statement ($db_location, $table_name, $param, $where_param);
				
				if ($result['port_id'] == "")
				{
					$insert_parameters = "port_id, dev_name, line_type, coding, framing, clock, ref_clock, echo, dtmf, fax, lbo, txtristate, sigmode, impedence, rx_level, rxgain, txgain";	
					$values = $a . ", \"" . $t1e1->card_name . "\", \"" . $t1e1->t1e1 . "\", \"" .$_REQUEST['coding'] . "\", \"" . $_REQUEST['framing'] . "\", \"" . $_REQUEST['clock'] . "\",\"" . $_REQUEST['ref_clock'] . "\", \"" .$_REQUEST['HW_EC']. "\", \"" . $_REQUEST['dtmf'] . "\", \"" . $_REQUEST['HW_FAX'] . "\", \"" . $_REQUEST['lbo'] . "\", \"" . $_REQUEST['txtristate'] . "\", \"" . $_REQUEST['sig_mode'] . "\", \"" . $_REQUEST['impedence'] . "\", \"" . $_REQUEST['rx_level'] . "\", \"" . $_REQUEST['rxgain'] . "\", \"" . $_REQUEST['txgain'] . "\"";	
				
					//Insert into database
					$data->insert_statement($db_location, $table_name, $insert_parameters, $values);							
				}	
				else
				{
					$update_param = "port_id = " . $a . ", dev_name = \"" . $t1e1->card_name . "\", line_type = \"" . $t1e1->t1e1 . "\", coding = \"" .$_REQUEST['coding'] . "\", framing = \"" . $_REQUEST['framing'] . "\", clock = \"" . $_REQUEST['clock'] . "\", ref_clock = \"" . $_REQUEST['ref_clock'] . "\", echo = \"" .$_REQUEST['HW_EC']. "\", dtmf = \"" . $_REQUEST['dtmf'] . "\", fax = \"" . $_REQUEST['HW_FAX'] . "\", lbo = \"" . $_REQUEST['lbo'] . "\", txtristate = \"" . $_REQUEST['txtristate'] . "\", sigmode = \"" . $_REQUEST['sig_mode'] . "\", impedence = \"" . $_REQUEST['impedence'] . "\", rx_level = \"" . $_REQUEST['rx_level'] . "\", rxgain = \"" . $_REQUEST['rxgain'] . "\", txgain = \"" . $_REQUEST['txgain'] . "\"";
						
					$where_param = "port_id = " . $a;
					
					//Update the table with the new values
					$data->update_table ($db_location, $table_name, $update_param, $where_param);
				}
			}

			//redirect to status page
			header( 'Location:../wanrouterhwprobe.php' );													
		}
	}
	
}
//If Cancel is clicked
if ($_REQUEST['cancel'] == "Cancel Configuration")
{
	//Redirects to the profile creation page
	header( 'Location:../wanrouterhwprobe.php' );
}	
        

require_once "../fusionpbx/includes/header.php";

//Displays options for T1/E1/J1
$t1e1->main();		

//FusionPBX Integration
require_once "../fusionpbx/includes/footer.php";
?>
          